org.springframework.beans.propertyeditors

## Class CustomDateEditor

- java.lang.Object
- - java.beans.PropertyEditorSupport
  - - org.springframework.beans.propertyeditors.CustomDateEditor

All Implemented Interfaces:
  PropertyEditor

    public class CustomDateEditor
    extends PropertyEditorSupport

Property editor for `java.util.Date`, supporting a custom `java.text.DateFormat`.

This is not meant to be used as system PropertyEditor but rather as locale-specific date editor within custom controller code, parsing user-entered number strings into Date properties of beans and rendering them in the UI form.

In web MVC code, this editor will typically be registered with `binder.registerCustomEditor` calls in a custom `initBinder` method.

Since:
  28.04.2003
Author:
  Juergen Hoeller
See Also:
  `Date`, `DateFormat`, `DataBinder.registerCustomEditor(java.lang.Class<?>, java.beans.PropertyEditor)`, `BaseCommandController.initBinder(javax.servlet.http.HttpServletRequest, org.springframework.web.bind.ServletRequestDataBinder)`

### Constructor Summary

Constructors
Constructor and Description
`CustomDateEditor(DateFormat dateFormat, boolean allowEmpty)` Create a new CustomDateEditor instance, using the given DateFormat for parsing and rendering.
`CustomDateEditor(DateFormat dateFormat, boolean allowEmpty, int exactDateLength)` Create a new CustomDateEditor instance, using the given DateFormat for parsing and rendering.

### Method Summary

Methods
`String` `getAsText()` Format the Date as String, using the specified DateFormat.
`void` `setAsText(String text)` Parse the Date from the given text, using the specified DateFormat.

### Methods inherited from class java.beans.PropertyEditorSupport

`addPropertyChangeListener, firePropertyChange, getCustomEditor, getJavaInitializationString, getSource, getTags, getValue, isPaintable, paintValue, removePropertyChangeListener, setSource, setValue, supportsCustomEditor`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CustomDateEditor

    public CustomDateEditor(DateFormat dateFormat,
                    boolean allowEmpty)

Create a new CustomDateEditor instance, using the given DateFormat for parsing and rendering.

The "allowEmpty" parameter states if an empty String should be allowed for parsing, i.e. get interpreted as null value. Otherwise, an IllegalArgumentException gets thrown in that case.

Parameters:
  `dateFormat` - DateFormat to use for parsing and rendering
  `allowEmpty` - if empty strings should be allowed

#### CustomDateEditor

    public CustomDateEditor(DateFormat dateFormat,
                    boolean allowEmpty,
                    int exactDateLength)

Create a new CustomDateEditor instance, using the given DateFormat for parsing and rendering.

The "allowEmpty" parameter states if an empty String should be allowed for parsing, i.e. get interpreted as null value. Otherwise, an IllegalArgumentException gets thrown in that case.

The "exactDateLength" parameter states that IllegalArgumentException gets thrown if the String does not exactly match the length specified. This is useful because SimpleDateFormat does not enforce strict parsing of the year part, not even with `setLenient(false)`. Without an "exactDateLength" specified, the "01/01/05" would get parsed to "01/01/0005". However, even with an "exactDateLength" specified, prepended zeros in the day or month part may still allow for a shorter year part, so consider this as just one more assertion that gets you closer to the intended date format.

Parameters:
  `dateFormat` - DateFormat to use for parsing and rendering
  `allowEmpty` - if empty strings should be allowed
  `exactDateLength` - the exact expected length of the date String

### Method Detail

#### setAsText

    public void setAsText(String text)
                   throws IllegalArgumentException

Parse the Date from the given text, using the specified DateFormat.

Specified by:
  `setAsText` in interface `PropertyEditor`
Overrides:
  `setAsText` in class `PropertyEditorSupport`
Throws:
  `IllegalArgumentException`

#### getAsText

    public String getAsText()

Format the Date as String, using the specified DateFormat.

Specified by:
  `getAsText` in interface `PropertyEditor`
Overrides:
  `getAsText` in class `PropertyEditorSupport`